/** ----------------------------------- -o-
 *  Urn.java
 *
 * Random integers where each is returned once before repetition. 
 * 
 * INPUT--  size
 * OUTPUT--  
 *   random value unique in a field of size
 *   cycleRestarted is true when beginning new cycle through random field
 * METHODS--  size reset next
 *
 * @version 0.1    CREATED: Thu Sep 14 00:00:00 PDT 2009
 * @author  dreeder@danaprajna.com
 */ 							// -o-
package com.danaprajna;

import java.util.Arrays;
import com.cycling74.max.*;


public class Urn extends MaxObject
{ 							
  private DebugLabel l = new DebugLabel("Urn", true);
  private ToolBox    t = new ToolBox();

  public  boolean[]  ht = null;
  private int 	     htSize = -1;
  private int 	     openSpot = -1;

  public boolean     cycleRestarted = true;

  
  //----------------------------------- -o-
  // constructors
  //
  public Urn(int i)  { size(i); }

  public void anything(String m, Atom[] args) 
    { l.arglist("anything", m, args); }


  //----------------------------------- --o-
  public void reset()  
    { Arrays.fill(ht, false); cycleRestarted = true; }


  public void size(int i) {
    if (1>=i)  
      { l.sm("size").merr("size must be greater than one").ms(); return; }

    if (i==htSize)  { reset(); }

    htSize = i;
    ht = new boolean[htSize]; 	// TBD FIX  resize properly...
    reset();
  }


  //----------------------------------- -o-
  public int next() { 
    int beginAt = openSpot = t.getRand(htSize);
    cycleRestarted = false;

    while (ht[openSpot]) {
      openSpot = ++openSpot % htSize;
      if (beginAt==openSpot)  { reset(); }
    }
    ht[openSpot] = true;

    return(openSpot);
  }  // next()

}  // public class Urn extends MaxObject
  
